#include "ty_pin.h"
#include "ty_ble.h"
#include "ty_uart.h"
#include "ty_rtc.h"
#include "ty_pwm.h"
#include "ty_adc.h"
#include "ty_i2c.h"
#include "tuya_ble_sdk_test.h"
#include "nrf_drv_gpiote.h"
#include "bsp.h"
#include "tuya_ble_api.h"
#include "ty_oled.h"




/*********************************************************************
 * LOCAL CONSTANT
 */

/*********************************************************************
 * LOCAL STRUCT
 */

/*********************************************************************
 * LOCAL VARIABLE
 */

/*********************************************************************
 * VARIABLE
 */

/*********************************************************************
 * LOCAL FUNCTION
 */




/*********************************************************
FN: 
*/
static void in_pin_handler(nrf_drv_gpiote_pin_t pin, nrf_gpiote_polarity_t action)
{
}
static void bsp_event_handler(bsp_event_t event)
{
    TY_PRINTF("event: %d", event);
    switch (event)
    {
        case BSP_EVENT_KEY_0: { //13
            tuya_ble_device_factory_reset();
            
            ty_oled_clear();
            ty_oled_show_string(12, 1, "Device Unbound", 16);
        } break;

        case BSP_EVENT_KEY_1: { //14
#if TUYA_BLE_SDK_TEST
            tuya_ble_sdk_test_wake_up_handler();
/*
#define BUTTON_3       33 //15
#define BUTTON_4       34 //16
*/
#endif
        } break;

        case BSP_EVENT_KEY_2: {
        } break;

        case BSP_EVENT_KEY_3: {
        } break;
        
        default: {
        } break;
    }
}

/*********************************************************
FN: 
*/
uint32_t ty_pin_init(uint8_t pin, ty_pin_mode_t mode)
{
    uint32_t ret = bsp_init(BSP_INIT_BUTTONS, bsp_event_handler);
    APP_ERROR_CHECK(ret);
//    uint32_t ret;
//    
//    if(!nrf_drv_gpiote_is_init()) {
//        ret = nrf_drv_gpiote_init();
//        APP_ERROR_CHECK(ret);
//    }
    
//    //set pin inout
//    switch(mode & TY_PIN_INOUT_MASK) {
//        case TY_PIN_IN: {
//            nrf_drv_gpiote_in_config_t in_config = GPIOTE_CONFIG_IN_SENSE_TOGGLE(true);
//            in_config.pull = NRF_GPIO_PIN_PULLUP;

//            ret = nrf_drv_gpiote_in_init(pin, &in_config, in_pin_handler);
//            APP_ERROR_CHECK(ret);
//        } break;
//        
//        case TY_PIN_OUT_PP: {
//            nrf_drv_gpiote_out_config_t out_config = GPIOTE_CONFIG_OUT_SIMPLE(false);
//            
//            ret = nrf_drv_gpiote_out_init(pin, &out_config);
//            APP_ERROR_CHECK(ret);
//        } break;
//        
//        case TY_PIN_OUT_OD: {
//        } break;
//        
//        default: {
//        } break;
//    }

//    //set pin mode
//    switch(mode & TY_PIN_MODE_MASK) {
//        case TY_PIN_PULL_UP: {
//        } break;
//        
//        case TY_PIN_PULL_DOWN: {
//        } break;
//        
//        case TY_PIN_PULL_NONE: {
//        } break;
//        
//        default: {
//        } break;
//    }

//    //set pin level
//    switch(mode & TY_PIN_INIT_MASK) {
//        case TY_PIN_INIT_LOW: {
//        } break;
//        
//        case TY_PIN_INIT_HIGH: {
//        } break;
//        
//        default: {
//        } break;
//    }
    
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_pin_set(uint8_t pin, ty_pin_level_t level)
{
    if(level == TY_PIN_HIGH) {
        nrf_drv_gpiote_out_set(pin);
    } else {
        nrf_drv_gpiote_out_clear(pin);
    }
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_pin_get(uint8_t pin, ty_pin_level_t* p_level)
{
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_pin_control(uint8_t pin, uint8_t cmd, void* arg)
{
    nrf_drv_gpiote_in_event_enable(pin, true);
    return 0;
}

/*********************************************************
FN: 
*/
uint32_t ty_pin_uninit(uint8_t pin, ty_pin_mode_t mode)
{
    return 0;
}







